C **********************************************************************
C PROGRAMM ZUR KONVERTIERUNG DER fort.* GESIMA DATEIEN INS
C V5D FORMAT FUER VIS5D
C AKTUELL:
C 24 Ausgabeschritte
C 15+1 Layers = NZ (der 16te ist der 0-Layer = Erdoberflaeche
C NX = 28
C NY = 22
C                       fort.52 => U-Komp Wind
C                       fort.53 => U-Komp Wind
C                       fort.54 => U-Komp Wind
C                       fort.76 => RAIN WATER (G/KG)
C                       fort.73 => TEMP (K)
C WR, 26/07/00
C **********************************************************************
      PROGRAM GES2V5D
      
      IMPLICIT NONE
      
      INTEGER NX
      INTEGER NY
      INTEGER NZ
      PARAMETER(NX=28,NY=22,NZ=15)
      INTEGER T, L, I, J, TMAX, LAYER, II, JJ, X, Y
      DOUBLE PRECISION RAIN(NX,NY,0:NZ,50),TEMP(NX,NY,0:NZ,50),
     & POND(141,112,50), SRFWAT(NX,NY,0:NZ,50),
     & U(NX,NY,0:NZ,50),V(NX,NY,0:NZ,50),W(NX,NY,0:NZ,50),
     & SHUM(NX,NY,0:NZ,50),RHUM(NX,NY,0:NZ,50),
     & CW(NX,NY,0:NZ,50),CI(NX,NY,0:NZ,50),GRP(NX,NY,0:NZ,50)
      DOUBLE PRECISION SUMIN, SUMOUT, DIFF
      CHARACTER FORM1*30, FORM1B*30, FORM2*30, FORM2B*30, 
     & FORM3*30, FORM3B*30, FORMOUT*30
      
C ----------------------------------------------------------------------
      TMAX = 24
C ----------------------------------------------------------------------
      FORM1  = '(5(2X,E12.6))'
      FORM1B = '(3(2X,E12.6))'

      FORM2  = '(5(1X,E13.6))'
      FORM2B = '(3(1X,E13.6))'

      FORM3  = '(5(4X,F10.6))'
      FORM3B = '(3(4X,F10.6))'
      
C ~~~~~~~~~~~~~~~~~ OUTPUT FORMAT ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      FORMOUT = '(28(E10.4,2X))'
C ----------------------------------------------------------------------
      
      SUMIN  = 0.0D0
      SUMOUT = 0.0D0
      DIFF   = 0.0D0
      
C **********************************************************************
C                             INPUT
C **********************************************************************

      WRITE(*,*) 'START READING INPUT'

C POND SHALL BECOME RAIN AT LAYER ZERO !!!
      OPEN(90,FILE='pond.out')
      DO T = 1, TMAX
      READ(90,*) 
            DO J=1, 112
            READ(90,'(141(E10.4,2X))') (POND(I,J,T), I=1,141)
            ENDDO
      
C ----------------------------------------------------------------------      
            II = 0
            DO X = 1, NX
            II = MIN(141,II+5)
                  JJ = 0
                  DO Y = 1, NY
                  JJ = MIN(112,JJ+5)
                  SRFWAT(X,Y,NZ,T) = POND(II,JJ,T)
                  ENDDO
            ENDDO
C ----------------------------------------------------------------------
      ENDDO            
C Das ist nur eine temporaere Loseung, die restlichen 15 Layer von
C     SRFWAT werden mit 0 initialisiert      
      DO T=1, TMAX
      DO I = 1, NX
      DO J = 1, NY
      DO L =0, NZ-1
      SRFWAT(X,Y,L,T) = 0.0D0      
      ENDDO
C LAYER NZ (=15) von RAIN, U, V, W wird mit 0 vollgeschrieben
      RAIN(I,J,NZ,T)     = 0.0D0
         U(I,J,NZ,T)     = 0.0D0
         V(I,J,NZ,T)     = 0.0D0
         W(I,J,NZ,T)     = 0.0D0
      SHUM(I,J,NZ,T)     = 0.0D0
      RHUM(I,J,NZ,T)     = 0.0D0
        CW(I,J,NZ,T)     = 0.0D0
        CI(I,J,NZ,T)     = 0.0D0
       GRP(I,J,NZ,T)     = 0.0D0
      ENDDO
      ENDDO
      ENDDO

C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      OPEN(52,FILE='fort.52')      
      REWIND(52)      
      DO T=1, TMAX      
      READ(52,*) 
      READ(52,*)            
            DO L=0, NZ-1
            READ(52,*) LAYER
                  DO J =1, NY
                  READ(52,FORM2 ) (U(I,J,L,T), I=1,  5)
                  READ(52,FORM2 ) (U(I,J,L,T), I=6,  10)
                  READ(52,FORM2 ) (U(I,J,L,T), I=11, 15)
                  READ(52,FORM2 ) (U(I,J,L,T), I=16, 20)
                  READ(52,FORM2 ) (U(I,J,L,T), I=21, 25)
                  READ(52,FORM2B) (U(I,J,L,T), I=26, 28)
                  ENDDO                                                                        
            ENDDO
C LAYERS FINISHED      
      ENDDO
C TIMES FINISHED   
      WRITE(*,*) 'FINISHED READING U-WIND'
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

      OPEN(53,FILE='fort.53')      
      REWIND(53)      
      DO T=1, TMAX      
      READ(53,*) 
      READ(53,*)            
            DO L=0, NZ-1
            READ(53,*) LAYER                       
                  DO J =1, NY
                  READ(53,FORM2 ) (V(I,J,L,T), I=1,  5)
                  READ(53,FORM2 ) (V(I,J,L,T), I=6,  10)
                  READ(53,FORM2 ) (V(I,J,L,T), I=11, 15)
                  READ(53,FORM2 ) (V(I,J,L,T), I=16, 20)
                  READ(53,FORM2 ) (V(I,J,L,T), I=21, 25)
                  READ(53,FORM2B) (V(I,J,L,T), I=26, 28)
                  ENDDO                                                                        
            ENDDO
C LAYERS FINISHED      
      ENDDO
C TIMES FINISHED   
      WRITE(*,*) 'FINISHED READING V-WIND'
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      OPEN(54,FILE='fort.54')      
      REWIND(54)      
      DO T=1, TMAX      
      READ(54,*) 
      READ(54,*)            
            DO L=0, NZ-1
            READ(54,*) LAYER                       
                  DO J =1, NY
                  READ(54,FORM2 ) (W(I,J,L,T), I=1,  5)
                  READ(54,FORM2 ) (W(I,J,L,T), I=6,  10)
                  READ(54,FORM2 ) (W(I,J,L,T), I=11, 15)
                  READ(54,FORM2 ) (W(I,J,L,T), I=16, 20)
                  READ(54,FORM2 ) (W(I,J,L,T), I=21, 25)
                  READ(54,FORM2B) (W(I,J,L,T), I=26, 28)
                  ENDDO                                                                        
            ENDDO
C LAYERS FINISHED      
      ENDDO
C TIMES FINISHED   
      WRITE(*,*) 'FINISHED READING U-WIND'
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      OPEN(76,FILE='fort.76')      
      REWIND(76)      
      DO T=1, TMAX      
      READ(76,*) 
      READ(76,*)            
            DO L=0, NZ-1
            READ(76,*) LAYER                       
                  DO J =1, NY
                  READ(76,FORM1 ) (RAIN(I,J,L,T), I=1,  5)
                  READ(76,FORM1 ) (RAIN(I,J,L,T), I=6,  10)
                  READ(76,FORM1 ) (RAIN(I,J,L,T), I=11, 15)
                  READ(76,FORM1 ) (RAIN(I,J,L,T), I=16, 20)
                  READ(76,FORM1 ) (RAIN(I,J,L,T), I=21, 25)
                  READ(76,FORM1B) (RAIN(I,J,L,T), I=26, 28)
                  ENDDO                                                                        
            ENDDO
C LAYERS FINISHED      
      ENDDO
C TIMES FINISHED   
      WRITE(*,*) 'FINISHED READING RAIN'
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      OPEN(73,FILE='fort.73')      
      REWIND(73)            
      DO T=1, TMAX      
      READ(73,*)            
      READ(73,*)                  
            DO L=0, NZ
            READ(73,*) LAYER      
                  DO J =1, NY
                  READ(73,FORM3 ) (TEMP(I,J,L,T), I=1,  5)
                  READ(73,FORM3 ) (TEMP(I,J,L,T), I=6,  10)
                  READ(73,FORM3 ) (TEMP(I,J,L,T), I=11, 15)
                  READ(73,FORM3 ) (TEMP(I,J,L,T), I=16, 20)
                  READ(73,FORM3 ) (TEMP(I,J,L,T), I=21, 25)
                  READ(73,FORM3B ) (TEMP(I,J,L,T), I=26, 28)
                  ENDDO                                                                        
            ENDDO
C LAYERS FINISHED      
      ENDDO
C TIMES FINISHED   
      WRITE(*,*) 'FINISHED READING TEMPERATURE'
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      OPEN(70,FILE='fort.70')
      REWIND(70)            
      DO T=1, TMAX      
      READ(70,*)            
      READ(70,*)                  
            DO L=0, NZ-1
            READ(70,*) LAYER      
                  DO J =1, NY
                  READ(70,FORM1 ) (SHUM(I,J,L,T), I=1,  5)
                  READ(70,FORM1 ) (SHUM(I,J,L,T), I=6,  10)
                  READ(70,FORM1 ) (SHUM(I,J,L,T), I=11, 15)
                  READ(70,FORM1 ) (SHUM(I,J,L,T), I=16, 20)
                  READ(70,FORM1 ) (SHUM(I,J,L,T), I=21, 25)
                  READ(70,FORM1B) (SHUM(I,J,L,T), I=26, 28)
                  ENDDO                                                                        
            ENDDO
C LAYERS FINISHED      
      ENDDO
C TIMES FINISHED   
      WRITE(*,*) 'FINISHED READING SPECIFIC HUMIDITY'
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      OPEN(71,FILE='fort.71')
      REWIND(70)            
      DO T=1, TMAX      
      READ(71,*)            
      READ(71,*)                  
            DO L=0, NZ-1
            READ(71,*) LAYER      
                  DO J =1, NY
                  READ(71,FORM3 ) (RHUM(I,J,L,T), I=1,  5)
                  READ(71,FORM3 ) (RHUM(I,J,L,T), I=6,  10)
                  READ(71,FORM3 ) (RHUM(I,J,L,T), I=11, 15)
                  READ(71,FORM3 ) (RHUM(I,J,L,T), I=16, 20)
                  READ(71,FORM3 ) (RHUM(I,J,L,T), I=21, 25)
                  READ(71,FORM3B) (RHUM(I,J,L,T), I=26, 28)
                  ENDDO                                                                        
            ENDDO
C LAYERS FINISHED      
      ENDDO
C TIMES FINISHED   
      WRITE(*,*) 'FINISHED READING REL. HUMIDITY'
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      OPEN(74,FILE='fort.74')
      REWIND(74)            
      DO T=1, TMAX      
      READ(74,*)            
      READ(74,*)                  
            DO L=0, NZ-1
            READ(74,*) LAYER      
                  DO J =1, NY
                  READ(74,FORM1 ) (CW(I,J,L,T), I=1,  5)
                  READ(74,FORM1 ) (CW(I,J,L,T), I=6,  10)
                  READ(74,FORM1 ) (CW(I,J,L,T), I=11, 15)
                  READ(74,FORM1 ) (CW(I,J,L,T), I=16, 20)
                  READ(74,FORM1 ) (CW(I,J,L,T), I=21, 25)
                  READ(74,FORM1B) (CW(I,J,L,T), I=26, 28)
                  ENDDO                                                                        
            ENDDO
C LAYERS FINISHED      
      ENDDO
C TIMES FINISHED   
      WRITE(*,*) 'FINISHED READING CLOUD WATER'
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      OPEN(75,FILE='fort.75')
      REWIND(75)            
      DO T=1, TMAX      
      READ(75,*)            
      READ(75,*)                  
            DO L=0, NZ-1
            READ(75,*) LAYER      
                  DO J =1, NY
                  READ(75,FORM1 ) (CI(I,J,L,T), I=1,  5)
                  READ(75,FORM1 ) (CI(I,J,L,T), I=6,  10)
                  READ(75,FORM1 ) (CI(I,J,L,T), I=11, 15)
                  READ(75,FORM1 ) (CI(I,J,L,T), I=16, 20)
                  READ(75,FORM1 ) (CI(I,J,L,T), I=21, 25)
                  READ(75,FORM1B) (CI(I,J,L,T), I=26, 28)
                  ENDDO                                                                        
            ENDDO
C LAYERS FINISHED      
      ENDDO
C TIMES FINISHED   
      WRITE(*,*) 'FINISHED READING CLOUD ICE'
C ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
      OPEN(78,FILE='fort.78')
      REWIND(78)            
      DO T=1, TMAX      
      READ(78,*)            
      READ(78,*)                  
            DO L=0, NZ-1
            READ(78,*) LAYER      
                  DO J =1, NY
                  READ(78,FORM1 ) (GRP(I,J,L,T), I=1,  5)
                  READ(78,FORM1 ) (GRP(I,J,L,T), I=6,  10)
                  READ(78,FORM1 ) (GRP(I,J,L,T), I=11, 15)
                  READ(78,FORM1 ) (GRP(I,J,L,T), I=16, 20)
                  READ(78,FORM1 ) (GRP(I,J,L,T), I=21, 25)
                  READ(78,FORM1B) (GRP(I,J,L,T), I=26, 28)
                  ENDDO                                                                        
            ENDDO
C LAYERS FINISHED      
      ENDDO
C TIMES FINISHED   
      WRITE(*,*) 'FINISHED READING GRAUPEL'
C **********************************************************************
C                       OUTPUT
C **********************************************************************

      WRITE(*,*) 'START WRITING OUTPUT'

C WRITE A NEW FILE
      OPEN(98,FILE='ges.out')
C only 24 output steps: =>      
      DO T = 1, TMAX
      
            DO L = NZ, 0, -1
                  DO J = 1, NY
                  WRITE(98,FORMOUT) (U(I,J,L,T), I=1,NX)
                  ENDDO
            ENDDO

            DO L = NZ, 0, -1
                  DO J = 1, NY
                  WRITE(98,FORMOUT) (V(I,J,L,T), I=1,NX)                  
                  ENDDO
            ENDDO


            DO L = NZ, 0, -1
                  DO J = 1, NY
                  WRITE(98,FORMOUT) (W(I,J,L,T), I=1,NX)
                  ENDDO
            ENDDO

            DO L = NZ, 0, -1
                  DO J = 1, NY
                  WRITE(98,FORMOUT) (RAIN(I,J,L,T), I=1,NX)
                  ENDDO
            ENDDO


            DO L = NZ, 0, -1
                  DO J = 1, NY
                  WRITE(98,FORMOUT) (TEMP(I,J,L,T), I=1,NX)
                  ENDDO
            ENDDO

            DO L = NZ, 0, -1
                  DO J = 1, NY
                  WRITE(98,FORMOUT) (SRFWAT(I,J,L,T), I=1,NX)
                  ENDDO
            ENDDO
            DO L = NZ, 0, -1
                  DO J = 1, NY
                  WRITE(98,FORMOUT) (SHUM(I,J,L,T), I=1,NX)
                  ENDDO
            ENDDO
            DO L = NZ, 0, -1
                  DO J = 1, NY
                  WRITE(98,FORMOUT) (RHUM(I,J,L,T), I=1,NX)
                  ENDDO
            ENDDO
            DO L = NZ, 0, -1
                  DO J = 1, NY
                  WRITE(98,FORMOUT) (CW(I,J,L,T), I=1,NX)
                  ENDDO
            ENDDO
            DO L = NZ, 0, -1
                  DO J = 1, NY
                  WRITE(98,FORMOUT) (CI(I,J,L,T), I=1,NX)
                  ENDDO
            ENDDO
            DO L = NZ, 0, -1
                  DO J = 1, NY
                  WRITE(98,FORMOUT) (GRP(I,J,L,T), I=1,NX)
                  ENDDO
            ENDDO

      ENDDO

      WRITE(*,*) 'FINISHED WRITING ges.out'

      STOP
      END
